MULTIFY(1)

NAME
multify - manipulate .mf multifiles

SYNOPSIS
multify -[c|r|u|t|x] -f multifile_name.mf [ options ] subfile_name ...

DESCRIPTION
multify is used to store and extract files from a Panda Multifile. This is similar to a tar or zip file in that it is an archive file that contains a number of subfiles that may later be extracted.

Panda's VirtualFileSystem is capable of mounting Multifiles for direct access to the subfiles contained within without having to extract them out to independent files first.

The command-line options for multify are designed to be similar to those for tar(1), the traditional Unix archiver utility.

OPTIONS
You must specify exactly one of the following command switches:

-c  Create a new Multifile archive. Subfiles named on the command line will be added to the new Multifile. If the Multifile already exists, it is first removed.

-r  Rewrite an existing Multifile archive. Subfiles named on the command line will be added to the Multifile or will replace subfiles within the Multifile with the same name. The Multifile will be repacked after completion, even if no Subfiles were added.

-u  Update an existing Multifile archive. This is similar to -r, except that files are compared byte-for-byte with their corresponding files in the archive first. If they have not changed, the multifile is not modified (other than to repack it if necessary).

-t  List the contents of an existing Multifile. With -v, this shows the size of each Subfile and its compression ratio, if compressed.

-x  Extract the contents of an existing Multifile. The Subfiles named on the command line, or all Subfiles if nothing is named, are extracted into the current directory or into whichever directory is specified with -C.

-k  Delete (kill) the named Subfiles from the Multifile. The Multifile will be repacked after completion.

You must always specify the following switch:

-f multifile_name.mf
    Names the Multifile that will be operated on.

The remaining switches are optional:

-v  Run verbosely. In -c, -r, or -x mode, list each file as it is written or extracted. In -t mode, list more information about each file.

-z  Compress subfiles as they are written to the Multifile. Unlike tar (but like zip), subfiles are compressed individually, instead of the entire archive being compressed as one stream. It is not necessary to specify -z when extracting compressed subfiles; they will always be decompressed automatically. Also see -Z, which restricts which subfiles will be compressed based on the filename extension.

-e  Encrypt subfiles as they are written to the Multifile using the password specified with -p, below. Subfiles are encrypted individually, rather than encrypting the entire multifile, and different subfiles may be encrypted using different passwords (although this requires running multify multiple times). It is not possible to encrypt the multifile's table of contents using this interface, but see the pencrypt(1) program to encrypt the entire multifile after it has been generated.

-p password
    Specifies the password to encrypt or decrypt subfiles. If this is not specified, and passwords are required, the user will be prompted from standard input.

-P prefix
    Specifies a header_prefix to write to the beginning of the multifile. This is primarily useful for creating a multifile that can be invoked directly as a program from the shell on Unix-like environments, for instance, p3d files. The header_prefix must begin with a hash mark and end with a newline; this will be enforced if it is not already so. This only has effect in conjunction with with -c, -u, or -k.

-F scale_factor
    Specify a Multifile scale factor. This is only necessary to support Multifiles that will exceed 4GB in size. The default scale factor is 1, which should be sufficient for almost any application, but the total size of the Multifile will be limited to 4GB * scale_factor. The size of individual subfiles may not exceed 4GB in any case.

-C extract_dir
    Change to the named directory before working on files; that is, extraction/creation/update and replace will be based on this path

-O  With -x, extract subfiles to standard output instead of to disk.

-Z extension_list
    Specify a comma-separated list of filename extensions that represent files that are not to be compressed. The default if this is omitted is "jpg,png,mp3,ogg". Specify -Z "" (be sure to include the space) to allow all files to be compressed.

-X extension_list
    Specify a comma-separated list of filename extensions that represent text files. These files are opened and read in text mode, and added to the multifile with the text flag set. The default if this is omitted is "txt". Specify -X "" (be sure to include the space) to record all files in binary mode.

-T flag
    Enable or disable the recording of file timestamps within the multifile. If flag is 1, timestamps will be recorded within the multifile for each subfile added; this is the default behavior. If <flag> is 0, timestamps will not be recorded, which will make it easier to do a bitwise comparison between multifiles to determine whether their contents are equivalent.

-1 .. -9
    Specify the compression level when -z is in effect. Larger numbers generate slightly smaller files, but compression takes longer. The default is -6.

-S file.crt[,chain.crt[,file.key[,"password"]]]
    Sign the multifile. The signing certificate should be in PEM form in file.crt, with its private key in PEM form in file.key. If the key is encrypted on-disk, specify the decryption password as the third option. If a certificate chain is required, chain.crt should also be specified; note that the separating commas should be supplied even if this optional filename is omitted. You may also provide a single composite file that contains the certificate, chain, and key in the same file. PEM form is the form accepted by the Apache web server. The signature is written to the multifile to prove it is unchanged; any subsequent change to the multifile will invalidate the signature. This parameter may be repeated to sign the multifile with additional certificates.

SEE ALSO
pencrypt(1), pzip(1)